[tox]
minversion = 2.6
envlist = pep8-constraints,py27-constraints,py36-constraints,cover
skipsdist = True

[testenv]
usedevelop = True
install_command =
                  constraints: {[testenv:common-constraints]install_command}
                  pip install -U {opts} {packages}
setenv =
   VIRTUAL_ENV={envdir}
whitelist_externals =
    find
    rm

deps =
    -r{toxinidir}/test-requirements.txt
commands =
  find . -type f -name "*.pyc" -delete
  py.test -vvvv --html={envlogdir}/pytest_results.html --self-contained-html --durations=10 "os_faults/tests/unit" {posargs}
passenv = http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy NO_PROXY

[testenv:common-constraints]
basepython = python3
install_command = pip install -c{env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt} {opts} {packages}

[testenv:pep8]
basepython = python3
commands = flake8 . doc/ext

[testenv:pep8-constraints]
basepython = python3
install_command = {[testenv:common-constraints]install_command}
commands = {[testenv:pep8]commands}

[testenv:venv]
basepython = python3
commands = {posargs}

[testenv:venv-constraints]
basepython = python3
install_command = {[testenv:common-constraints]install_command}
commands = {posargs}

[testenv:cover]
basepython = python3
commands =
    py.test --cov-config .coveragerc --cov-report html --cov=os_faults "os_faults/tests/unit"
    coverage html -d {envlogdir}
    coverage report

[testenv:cover-constraints]
basepython = python3
install_command = {[testenv:common-constraints]install_command}
commands = {[testenv:cover]commands}

[testenv:devstack]
# to execute the tests:
#   1) create SSH key in os-faults folder: ssh-keygen -t rsa -f os_faults_key -N ''
#   2) copy public key into authorized_keys of user stack: cat os_faults_key.pub >> ~/.ssh/authorized_keys
#   3) run tests normally: tox -e devstack
basepython = python3
setenv = {[testenv]setenv}
         OS_TEST_PATH=./os_faults/tests/devstack
         OS_DEBUG=True
deps = {[testenv]deps}
extras =
commands =
  py.test -vvvv --html={envlogdir}/pytest_results.html --self-contained-html --durations=10 "os_faults/tests/devstack" {posargs}

[testenv:docs]
basepython = python3
commands =
    rm -rf doc/build
    python setup.py build_sphinx --warning-is-error

[testenv:releasenotes]
basepython = python3
commands =
  sphinx-build -a -E -W -d releasenotes/build/doctrees -b html releasenotes/source releasenotes/build/html

[testenv:docs-constraints]
basepython = python3
install_command = {[testenv:common-constraints]install_command}
commands = {[testenv:docs]commands}

[testenv:debug]
basepython = python3
commands = oslo_debug_helper {posargs}

[testenv:debug-constraints]
basepython = python3
install_command = {[testenv:common-constraints]install_command}
commands = {[testenv:debug]commands}


[flake8]
# E123 skipped because it is ignored by default in the default pep8.
# E125 skipped until https://github.com/jcrocholl/pep8/issues/126 is resolved.
# E731 skipped as assign a lambda expression
ignore = E123,E125,E731
show-source = True
exclude=.venv,.git,.tox,dist,doc,*lib/python*,*egg,build
